//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <Ice/Ice.h>
#include "udi_client_form.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TXEbugTestFrame *XEbugTestFrame;
//---------------------------------------------------------------------------
__fastcall TXEbugTestFrame::TXEbugTestFrame(TComponent* Owner)
    : TForm(Owner)
{
}

//------------------------------------------------
void __fastcall TXEbugTestFrame::FormCreate(TObject *Sender)
{
    try
    {
        m_ic   = Ice::initialize() ;
        m_base = m_ic->stringToProxy( "UDI_OPERATION:tcp -p 10001") ;
        m_udi  = MUdi::IUdiUserPrx::checkedCast( m_base ) ;
    }
    catch ( Ice::Exception const & e)
    {
        UnicodeString msg( e.what() ) ;
        Application->MessageBox( msg.c_str() , L"ERROR" , MB_OK ) ;
    }
}

//---------------------------------------------------------------------------
void __fastcall TXEbugTestFrame::okButtonClick(TObject *Sender)
{
    try
    {
        std::string rv = m_udi->doOperation( "OK" , "Not used" ) ;
        UnicodeString msg( rv.c_str() ) ;
        Application->MessageBox( msg.c_str() , L"OK" , MB_OK ) ;
    }
    catch ( ouMExceptions::MsgException2 const & e )
    {
        UnicodeString msg( e.Text.c_str() ) ;
        Application->MessageBox( msg.c_str() , L"ERROR" , MB_OK ) ;
    }
    catch( Ice::Exception const & e )
    {
        UnicodeString msg( e.what() ) ;
        Application->MessageBox( msg.c_str() , L"ERROR" , MB_OK ) ;
    }
    catch ( ... )
    {
        Application->MessageBox( L"Unknown error" , L"ERROR" , MB_OK ) ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TXEbugTestFrame::exceptionButtonClick(TObject *Sender)
{
    try
    {
        std::string rv = m_udi->doOperation( "Not OK" , "Not used" ) ;
        UnicodeString msg( rv.c_str() ) ;
        Application->MessageBox( msg.c_str() , L"OK" , MB_OK ) ;
    }
    catch ( ouMExceptions::MsgException2 const & e )
    {
        UnicodeString msg( e.Text.c_str() ) ;
        Application->MessageBox( msg.c_str() , L"ERROR" , MB_OK ) ;
    }
    catch( Ice::Exception const & e )
    {
        UnicodeString msg( e.what() ) ;
        Application->MessageBox( msg.c_str() , L"ERROR" , MB_OK ) ;
    }
    catch ( ... )
    {
        Application->MessageBox( L"Unknown error" , L"ERROR" , MB_OK ) ;
    }
}
//---------------------------------------------------------------------------

